unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, mk_usb_detector;

type
  TForm1 = class(TForm)
    MkUsbDetector1: TMkUsbDetector;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    procedure MkUsbDetector1ComDetect(Sender: TObject; ComPort: string;
      inout: Integer);
    procedure MkUsbDetector1UsbDetect(Sender: TObject; UsbName, vid,
      pid: string; inout: Integer);
    procedure MkUsbDetector1VolumeDetect(Sender: TObject; Volume: string;
      inout: Integer);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure MkUsbDetector1NewComInfo(Sender: TObject;
      MkComInfo: array of TMkComInfo; count: Integer);
    procedure MkUsbDetector1NewVolInfo(Sender: TObject;
      MkVolInfo: array of TMkVolInfo; count: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
    Memo1.Lines.Add( 'Developer info: '#13#10+'------------------'+
                      #13#10+MkUsbDetector1.GetDeveloperInfo(False) );
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i, len: Integer;
begin
  len := MkUsbDetector1.GetAvailableComPortsEx;
  Memo1.Lines.Add( '-------- All Com ports  -----------' );
  for i := 0 to len-1 do begin
    Memo1.Lines.Add( MkUsbDetector1.MkComInfo[i].sPort );
//    Memo1.Lines.Add( MkUsbDetector1.MkComInfo[i].VID );
//    Memo1.Lines.Add( MkUsbDetector1.MkComInfo[i].PID );
    Memo1.Lines.Add( MkUsbDetector1.MkComInfo[i].Serial );
//    Memo1.Lines.Add( MkUsbDetector1.MkComInfo[i].Manufacturer );
    Memo1.Lines.Add( MkUsbDetector1.MkComInfo[i].PortType );
//    Memo1.Lines.Add( MkUsbDetector1.MkComInfo[i].Chip );

    Memo1.Lines.Add( '-------------------' );
  end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var
  i, count: Integer;
begin
  count := MkUsbDetector1.GetAvailableVolumens();
  if count>0 then begin
    for i := 0 to count-1 do begin
      Memo1.Lines.Add( '' );
      Memo1.Lines.Add( '------- Volume Info -----------' );
      Memo1.Lines.Add( 'Device name: '+MkUsbDetector1.MkAllVolInfo[i].FulName );
      Memo1.Lines.Add( 'Device ID: '+MkUsbDetector1.MkAllVolInfo[i].DeviceID );
      Memo1.Lines.Add( 'Volume Name: '+MkUsbDetector1.MkAllVolInfo[i].VolName );
      Memo1.Lines.Add( 'Volume Serial: '+MkUsbDetector1.MkAllVolInfo[i].VolSerial );
      Memo1.Lines.Add( 'Volume Size: '+IntToStr(MkUsbDetector1.MkAllVolInfo[i].Size) );
      Memo1.Lines.Add( 'Volume FreeSpace: '+IntToStr(MkUsbDetector1.MkAllVolInfo[i].FreeSpace) );
      Memo1.Lines.Add( 'FileSystem: '+MkUsbDetector1.MkAllVolInfo[i].FileSystem );
    end;
  end;

end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  MkUsbDetector1.GetAvailableComPorts( ComboBox1.Items, CheckBox1.Checked );
  if ComboBox1.Items.Count>0 then ComboBox1.ItemIndex := 0;

  if CheckBox1.Checked then ComboBox1.Width := 205
  else ComboBox1.Width := 90
end;

procedure TForm1.ComboBox1DropDown(Sender: TObject);
begin
  MkUsbDetector1.GetAvailableComPorts( ComboBox1.Items, CheckBox1.Checked );
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MkUsbDetector1.GetAvailableComPorts( ComboBox1.Items, False );
  if ComboBox1.Items.Count>0 then ComboBox1.ItemIndex := 0;
end;

procedure TForm1.MkUsbDetector1ComDetect(Sender: TObject; ComPort: string;
  inout: Integer);
begin
  if inout=1 then Memo1.Lines.Add( 'pojawi si port: ' + ComPort )
  else Memo1.Lines.Add( 'znikn port: ' + ComPort );

  MkUsbDetector1.GetAvailableComPorts( ComboBox1.Items, CheckBox1.Checked );
end;

procedure TForm1.MkUsbDetector1NewComInfo(Sender: TObject;
  MkComInfo: array of TMkComInfo; count: Integer);
var
  i: Integer;
begin

  for i := 0 to count-1 do begin
    Memo1.Lines.Add( '------- new Com port Info -----------' );
    Memo1.Lines.Add( MkComInfo[i].sPort );
    Memo1.Lines.Add( MkComInfo[i].PortType );
    Memo1.Lines.Add( MkComInfo[i].VID + ' & ' + MkComInfo[i].PID );
    Memo1.Lines.Add( MkComInfo[i].Serial );
    Memo1.Lines.Add( MkComInfo[i].Manufacturer );
    Memo1.Lines.Add( MkComInfo[i].Chip );
  end;

end;

procedure TForm1.MkUsbDetector1NewVolInfo(Sender: TObject;
  MkVolInfo: array of TMkVolInfo; count: Integer);
var
  i: Integer;
begin

  for i := 0 to count-1 do begin
    Memo1.Lines.Add( '------- new Volume Info -----------' );
    Memo1.Lines.Add( 'Device name: '+MkVolInfo[i].FulName );
    Memo1.Lines.Add( 'Device ID: '+MkVolInfo[i].DeviceID );
    Memo1.Lines.Add( 'Volume Name: '+MkVolInfo[i].VolName );
    Memo1.Lines.Add( 'Volume Serial: '+MkVolInfo[i].VolSerial );
    Memo1.Lines.Add( 'Volume Size: '+IntToStr(MkVolInfo[i].Size) );
    Memo1.Lines.Add( 'Volume FreeSpace: '+IntToStr(MkVolInfo[i].FreeSpace) );
    Memo1.Lines.Add( 'FileSystem: '+MkVolInfo[i].FileSystem );
  end;

end;

procedure TForm1.MkUsbDetector1UsbDetect(Sender: TObject; UsbName, vid,
  pid: string; inout: Integer);
begin

  if inout=1 then begin
    Memo1.Lines.Add( 'podczono urzdzenie USB: ' + vid+ ' && '+pid + '  id: '+UsbName );
  end else begin
    Memo1.Lines.Add( 'odczono USB: ' + vid+ ' && '+pid + '  id: '+UsbName );
  end;
end;

procedure TForm1.MkUsbDetector1VolumeDetect(Sender: TObject; Volume: string;
  inout: Integer);
begin
  if inout=1 then Memo1.Lines.Add( 'pojawi si dysk: ' + Volume )
  else Memo1.Lines.Add( 'znikn dysk: ' + Volume );
end;

end.
